import _extends from 'babel-runtime/helpers/extends';
import request from './request';
import store from './store';
import event, { on, once, off, trigger } from './event';
import download from 'downloadjs';

/**
 * 导出常用请求函数到全局，其它高级配置使用 '.request.xxx()' 
 * 或直接 import request from 'cmn-utils/lib/request';
 */
var requestConfig = request.config;
var requestHeaders = request.headers;
var getform = request.getform;
var postform = request.postform;
var send = request.send;
var get = request.get;
var post = request.post;
var head = request.head;
var del = request['delete'];
var put = request.put;
var jsonp = request.jsonp;

export { request };

/**
 * 导出常用存储函数到全局，其它高级配置使用 '.store.xxx()' 
 * 或直接 import {xxx} from 'cmn-utils/lib/store'
 */
var setStore = store.setStore;
var getStore = store.getStore;
var removeStore = store.removeStore;
var clearStore = store.clearStore;

export { store };

/**
 * default export
 */
var L = _extends({
  // request api
  request: request, requestConfig: requestConfig, requestHeaders: requestHeaders, getform: getform, postform: postform, send: send, get: get, post: post, head: head, del: del, put: put, jsonp: jsonp,
  // store api
  store: store, setStore: setStore, getStore: getStore, removeStore: removeStore, clearStore: clearStore,
  // event api
  event: event, on: on, once: once, off: off, trigger: trigger,
  // download
  download: download
}, require('./utils'));

if (L.__esModule) delete L.__esModule;

export default L;